/*	Send ICMP 
	Coded by: Rohit Srivastava (rohit@comports.com)
	On: Jul 19 2:11:20 1998
*/


#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <netinet/in.h>
#include <linux/ip.h>
#include <linux/icmp.h>

#include <checksum.h>
#include <hostoaddr.h>

#define MAX_SIZE 65535

/* send <From> <Dest> */

int main( int nu_ar , char **po_ar )
{
	struct iphdr *ipHdr;
	struct icmphdr *icmpHdr;
	
	struct sockaddr_in addr ;

	char on = 1;

	int sock,
	    seq = 0;
	
	unsigned long tmp;
	
	char *buf = (unsigned char *)malloc( MAX_SIZE );

	bzero( buf , MAX_SIZE );
	
	if( nu_ar < 3 ) 
	{
	printf("send <From> <Dest>\n");
	exit(1);
	}
	if( (sock = socket( AF_INET , SOCK_RAW , IPPROTO_ICMP )) < 0 )
	{
	perror("Unable to allocate socket:");
	exit(1);
	}
	
	if( setsockopt(sock , IPPROTO_IP , IP_HDRINCL , &on , sizeof(on)) < 0 )
	{
	perror("Setsockopt Failed:");
	exit(1);
	}

	ipHdr = (struct iphdr *)buf ;

	ipHdr->ihl = 5;			 /* No options Feild */
	ipHdr->version = 0x4;
	ipHdr->tos =  0 ;			/* Low Delay */
	ipHdr->tot_len = sizeof(struct iphdr) + sizeof( struct icmphdr );
	ipHdr->id = htons( getpid() );
	ipHdr->frag_off = 0;
	ipHdr->ttl = 30;			/* 30 Hops max */
	ipHdr->protocol = IPPROTO_ICMP;
	ipHdr->check = 0 ;

	if( hostToaddr( po_ar[1], &tmp) < 0 )
	{
		perror("Host to addr conversion failed!");
		exit(1);
	}
	ipHdr->saddr = tmp;

	if( hostToaddr( po_ar[2], &tmp) < 0 )
	{
		perror("Host to addr conversion failed!");
		exit(1);
	}
	ipHdr->daddr = tmp;

	ipHdr->check = in_cksum( (unsigned short *)ipHdr , sizeof(struct iphdr) );

	icmpHdr = (struct icmphdr *)( buf + sizeof(struct iphdr) );
	icmpHdr->type = ICMP_ECHO;
	icmpHdr->code = 0;
	icmpHdr->un.echo.id = getpid();
	icmpHdr->un.echo.sequence = getpid();
	
	icmpHdr->checksum = in_cksum( (unsigned short *)icmpHdr , sizeof(struct icmphdr) );

	bzero( (char *)&addr, sizeof(addr) );
	addr.sin_addr.s_addr = ipHdr->daddr;
	addr.sin_family = AF_INET;
	
	if( sendto(sock , buf , sizeof(struct iphdr)+sizeof(struct icmphdr) , 0 , (struct sockaddr *)&addr , sizeof(addr)) < 0 )
	{
	perror("SendTo Error:");
	exit(1);
	}

	close(sock);
	exit(0);
}
