
/*	Rtt.h
	Coded By: Rohit Srivastava (rohit@comports.com)
		  http://members.tripod.com/~srohit
	On: I-don't-remember
*/

#define __INCLUDE_RTT__

/* 
Nu of packets to send per burst
*/
#define NU_PAKS 3

/*
Sleep time between each burst in secs
*/
#define T_BURST 1

/*
Timeout period for one packet burst in secs
*/

#define T_OUT 60

/* 	This utitlity measures RTT averaged 	*/

#define FILE_PATH "/tmp/rttfifo"

#define Alpha 0.9
#define Beta 2

// Local defines used by class

#define ONLY_RTT 0x01
#define NTRIES_SET 0x02

class RttAnalyser
{

		private:
			int nu_paks ;
			int timeout;
			int stime;
			int nu_tries;

			unsigned short seq;
			unsigned short id;

			int flag;

			char *destination;
				
		public:
			/* Sets the destination of the packets */
			void set_destination(char *);

			/* Total Number of tries in get_rtt() */
			void set_tries(int);

			/* # of packets sent in one packet burst, if it is
			   equal to 1 it will become equivalent to ping rtt
			   analysis 
			*/
			void set_nupaks(int);	

			/* Sleep time between packet bursts */
			void set_stime(int);	

			/* Timeout if there is no response */
			void set_timeout(int);

			/* Sends packets */
			int sendpaks(const char * , int);

			/* Recv's packet */	
			int recvpaks();

			/* Grapher, Set FILE_PATH to a file! or a named fifo */
			int srt_graph();	

			/* Use if you only require mrtt(mean RTT) and srtt(smoothed RTT) */
			int get_rtt( float * , float *); 
			
			RttAnalyser();	
			~RttAnalyser(); 
};
